float Var(float *d)
{
  float ave = 0.0;

  for(int i = 0; i < sqr(2 * MASKSIZE + 1); i++)
    {
      ave += d[i];
    }
  ave /= (float) sqr(2 * MASKSIZE + 1);
  
  float var = 0.0;
  for(int i = 0; i < sqr(2 * MASKSIZE + 1); i++)
    {
      var += (float) sqr(d[i] - ave);
    }

  return sqrt(var);
}

float Cov(float *d_left, float *d_right)
{

  float lave = 0.0;
  float rave = 0.0;
  for(int i = 0; i < sqr(2 * MASKSIZE + 1); i++)
    {
      lave += d_left[i];
      rave += d_right[i];
    }
  lave /= (float) sqr(2 * MASKSIZE + 1);
  rave /= (float) sqr(2 * MASKSIZE + 1);
  
  float var = 0.0;
  for(int i = 0; i < sqr(2 * MASKSIZE + 1); i++)
    {
      var += (float) (d_left[i] - lave) * (d_right[i] - rave);
    }

  return var;
}


float Correlation(PGM *img1, PGM *img2, int x, int y, int disparity, int width, int height)
{

  float *d_left;         /* (x, y)MASKSIZE^2β */
  float *d_right;        /* (x, y)MASKSIZE^2β */

  /* γ */
  if(((d_left  = (float*) malloc(sqr(2 * MASKSIZE + 1) * sizeof(float))) == NULL) ||
     ((d_right = (float*) malloc(sqr(2 * MASKSIZE + 1) * sizeof(float))) == NULL))
    {
      fprintf(stderr,"Malloc Error\n");
      return -1;
    }

  /* ħ̤׻ */
  int count = 0;
  for(int v = -MASKSIZE; v <= MASKSIZE; v++)
    {
      for(int u = -MASKSIZE; u <= MASKSIZE; u++)
	{
	  int lx = x + u;
	  int ly = y + v;
	  int rx = x + u - disparity;
	  int ry = x + v;

	  if((judge(lx, ly, width, height) == 1) && (judge(rx, ry, width, height) == 1))
	    {
	      /* ѿν */
	      d_left[count]  = img1[lx + ly * width];
	      d_right[count] = img2[rx + ry * width];
	    }
	  else
	    {
	      /* ΰγ */
	      free(d_left);
	      free(d_right);
	      return -1;
	    }
	  count ++;
	}
    }

  float tmp = Cov(d_left, d_right) / (Var(d_left) * Var(d_right));
  
  /* ΰγ */
  free(d_left);
  free(d_right);
  
  return tmp;
}







